<?php

/**
 * @file
 * Provides additional rules support for revisionreference fields.
 */

/**
 * Implementation of hook_rules_action_info().
 */
function revisionreference_rules_action_info() {
  $info = array();
  $info['revisionreference_rules_action_load'] = array(
    'label' => t('Load a referenced node revision'),
    'arguments' => array(
      'node' => array(
        'type' => 'node',
        'label' => t('Content containing the revisionreference field'),
      ),
    ),
    'new variables' => array(
      'referenced_node' => array(
        'type' => 'node',
        'label' => t('Referenced revision'),
      ),
    ),
    'module' => 'CCK',
    'help' => t('Note that if the field has multiple values, only the first content node will be loaded.'),
  );
  return $info;
}

function revisionreference_rules_action_load($node, $settings) {
  if ($vid = $node->{$settings['field']}[0]['vid']) {
    return array('referenced_node' => node_load(array('vid' => $vid), $vid));
  }
}

function revisionreference_rules_action_load_form($settings, &$form) {
  $settings += array('field' => '');
  $options = content_rules_get_field_names_by_type('revisionreference');
  $form['settings']['field'] = array(
    '#type' => 'select',
    '#title' => t('Field'),
    '#default_value' => $settings['field'],
    '#options' => $options,
    '#required' => TRUE,
    '#disabled' => empty($options),
    '#description' => empty($options) ? t('There are no revisionreference fields defined.') : '',
  );
}
